/////////////////////////////////////////////////////////////////////////////////
//
// countptr.cpp
//
//
/*
 * $Log: countptr.h,v $
 * Revision 1.3  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 * Revision 1.2  2000/07/07 14:11:55  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 */

#pragma once
#pragma warning(disable : 4786)


///////////////////////////////////////////////////////////////////////////
//
template <class T>
class count_ptr {
    T* ptr_;
    unsigned* cnt_;
    void inc_ref(const count_ptr& r);
    void dec_ref();
public:
    explicit count_ptr(T* p = 0) : ptr_(p), cnt_(0)
        { if (p) cnt_ = new unsigned(1); }
    count_ptr(const count_ptr& r)
        { inc_ref(r); }
    ~count_ptr()
        { dec_ref(); }
    count_ptr& operator=(const count_ptr& r)
        { if (this != &r) { dec_ref(); inc_ref(r); } return *this; }
    T* operator=(T* p)
        { if (ptr_ == p) return p; dec_ref(); if (p) cnt_ = new unsigned(1); ptr_ = p; return p; }
    T& operator*() const
        { return *ptr_; }
    T* operator->() const
        { return ptr_; }
    T* get() const
        { return ptr_; }
    bool unique() const
        { return cnt_ ? *cnt_ == 1 : true; }
    bool operator<(const count_ptr& r)
        { return *ptr_ < *r; }
};


///////////////////////////////////////////////////////////////////////////
//
template <class T>
inline void count_ptr<T>::dec_ref() {
    if (cnt_) {
        if (--*cnt_ == 0) {
            delete cnt_;
            delete ptr_;
        }
        cnt_ = 0;
        ptr_ = 0;
    }
}


template <class T>
inline void count_ptr<T>::inc_ref(const count_ptr<T>& r) {
    ptr_ = r.ptr_;
    cnt_ = r.cnt_;
    if (cnt_)
        ++*cnt_;
}


///////////////////////////////////////////////////////////////////////////
//
